import{S as of,i as rf,s as lf,e as a,k as p,w as u,t as r,M as pf,c as n,d as s,m as f,a as o,x as d,h as i,b as h,G as t,g as c,y as m,q as _,o as v,B as y,v as ff}from"../../chunks/vendor-hf-doc-builder.js";import{T as cf}from"../../chunks/Tip-hf-doc-builder.js";import{I as T}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as j}from"../../chunks/CodeBlock-hf-doc-builder.js";function hf(ua){let w;return{c(){w=r(`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},l(D){w=i(D,`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},m(D,k){c(D,w,k)},d(D){D&&s(w)}}}function uf(ua){let w,D,k,ne,Ft,De,Cn,Mt,Rn,da,oe,Fn,zt,Mn,zn,ma,re,Ht,S,_a,Hn,Vt,Vn,Gn,Gt,On,Bn,b,N,Ot,Ln,Xn,Bt,Yn,Wn,Lt,Kn,Qn,U,Xt,Jn,Zn,Yt,eo,to,Wt,so,ao,I,Kt,no,oo,Qt,ro,io,Jt,lo,po,C,Zt,fo,co,es,ho,uo,ts,mo,_o,R,ss,vo,yo,as,bo,go,ns,wo,$o,F,os,Eo,jo,rs,ko,To,is,Do,Ao,M,ls,Po,qo,ps,xo,So,fs,No,va,st,Uo,ya,z,ie,cs,Ae,Io,hs,Co,ba,Pe,qe,Ro,Fo,ga,le,Mo,us,zo,Ho,wa,xe,$a,H,pe,ds,Se,Vo,ms,Go,Ea,fe,Oo,Ne,Bo,Lo,ja,Ue,ka,V,ce,_s,Ie,Xo,vs,Yo,Ta,A,Wo,ys,Ko,Qo,bs,Jo,Zo,Da,Ce,Aa,he,er,gs,tr,sr,Pa,G,ue,ws,Re,ar,$s,nr,qa,P,or,Es,rr,ir,js,lr,pr,xa,Fe,Sa,O,de,ks,Me,fr,Ts,cr,Na,at,hr,Ua,me,Ia,_e,ur,nt,dr,mr,Ca,ze,Ra,ot,_r,Fa,B,ve,Ds,He,vr,As,yr,Ma,rt,br,za,q,gr,it,wr,$r,lt,Er,jr,Ha,ye,kr,pt,Tr,Dr,Va,Ve,Ga,ft,Ar,Oa,L,be,Ps,Ge,Pr,qs,qr,Ba,ct,xr,La,ge,Sr,xs,Nr,Ur,Xa,Oe,Ya,ht,Ir,Wa,ut,Cr,Ka,Be,Qa,X,we,Ss,Le,Rr,Ns,Fr,Ja,dt,Mr,Za,mt,zr,en,Xe,tn,Y,$e,Us,Ye,Hr,Is,Vr,sn,Ee,Gr,Cs,Or,Br,an,_t,Lr,nn,We,on,je,Xr,Rs,Yr,Wr,rn,Ke,ln,W,ke,Fs,Qe,Kr,Ms,Qr,pn,Te,zs,K,Hs,Jr,Zr,Vs,ei,ti,Gs,si,ai,g,Q,Os,ni,oi,Bs,ri,ii,Ls,li,pi,J,Xs,fi,ci,Ys,hi,ui,Ws,di,mi,Z,Ks,_i,vi,Qs,yi,bi,Js,gi,wi,ee,Zs,$i,Ei,ea,ji,ki,ta,Ti,Di,te,sa,Ai,Pi,aa,qi,xi,na,Si,Ni,se,oa,Ui,Ii,ra,Ci,Ri,ia,Fi,Mi,ae,la,zi,Hi,pa,Vi,Gi,fa,Oi,fn,vt,Bi,cn,x,ca,Li,Xi,ha,Yi,Wi,Je,Ki,Ze,Qi,Ji,hn,et,un;return De=new T({}),Ae=new T({}),xe=new j({props:{code:`import torch

torch.backends.cudnn.benchmark = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cudnn.benchmark = <span class="hljs-literal">True</span>`}}),Se=new T({}),Ue=new j({props:{code:`import torch

torch.backends.cuda.matmul.allow_tf32 = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cuda.matmul.allow_tf32 = <span class="hljs-literal">True</span>`}}),Ie=new T({}),Ce=new j({props:{code:`from torch import autocast
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
with autocast("cuda"):
    image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">from</span> torch <span class="hljs-keyword">import</span> autocast
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
<span class="hljs-keyword">with</span> autocast(<span class="hljs-string">&quot;cuda&quot;</span>):
    image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Re=new T({}),Fe=new j({props:{code:`pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Me=new T({}),me=new cf({props:{$$slots:{default:[hf]},$$scope:{ctx:ua}}}),ze=new j({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_attention_slicing()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_attention_slicing()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),He=new T({}),Ve=new j({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_vae_slicing()
images = pipe([prompt] * 32).images`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_vae_slicing()
images = pipe([prompt] * <span class="hljs-number">32</span>).images`}}),Ge=new T({}),Oe=new j({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Be=new j({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Le=new T({}),Xe=new j({props:{code:`print(pipe.unet.conv_out.state_dict()["weight"].stride())  # (2880, 9, 3, 1)
pipe.unet.to(memory_format=torch.channels_last)  # in-place operation
print(
    pipe.unet.conv_out.state_dict()["weight"].stride()
)  # (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works`,highlighted:`<span class="hljs-built_in">print</span>(pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride())  <span class="hljs-comment"># (2880, 9, 3, 1)</span>
pipe.unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># in-place operation</span>
<span class="hljs-built_in">print</span>(
    pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride()
)  <span class="hljs-comment"># (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works</span>`}}),Ye=new T({}),We=new j({props:{code:`import time
import torch
from diffusers import StableDiffusionPipeline
import functools

# torch disable grad
torch.set_grad_enabled(False)

# set variables
n_experiments = 2
unet_runs_per_experiment = 50

# load inputs
def generate_inputs():
    sample = torch.randn(2, 4, 64, 64).half().cuda()
    timestep = torch.rand(1).half().cuda() * 999
    encoder_hidden_states = torch.randn(2, 77, 768).half().cuda()
    return sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
).to("cuda")
unet = pipe.unet
unet.eval()
unet.to(memory_format=torch.channels_last)  # use channels_last memory format
unet.forward = functools.partial(unet.forward, return_dict=False)  # set return_dict=False as default

# warmup
for _ in range(3):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

# trace
print("tracing..")
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.eval()
print("done tracing")


# warmup and optimize graph
for _ in range(5):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


# benchmarking
with torch.inference_mode():
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        print(f"unet traced inference took {time.time() - start_time:.2f} seconds")
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        print(f"unet inference took {time.time() - start_time:.2f} seconds")

# save the model
unet_traced.save("unet_traced.pt")`,highlighted:`<span class="hljs-keyword">import</span> time
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> functools

<span class="hljs-comment"># torch disable grad</span>
torch.set_grad_enabled(<span class="hljs-literal">False</span>)

<span class="hljs-comment"># set variables</span>
n_experiments = <span class="hljs-number">2</span>
unet_runs_per_experiment = <span class="hljs-number">50</span>

<span class="hljs-comment"># load inputs</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_inputs</span>():
    sample = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">4</span>, <span class="hljs-number">64</span>, <span class="hljs-number">64</span>).half().cuda()
    timestep = torch.rand(<span class="hljs-number">1</span>).half().cuda() * <span class="hljs-number">999</span>
    encoder_hidden_states = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">77</span>, <span class="hljs-number">768</span>).half().cuda()
    <span class="hljs-keyword">return</span> sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)
unet = pipe.unet
unet.<span class="hljs-built_in">eval</span>()
unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># use channels_last memory format</span>
unet.forward = functools.partial(unet.forward, return_dict=<span class="hljs-literal">False</span>)  <span class="hljs-comment"># set return_dict=False as default</span>

<span class="hljs-comment"># warmup</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">3</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

<span class="hljs-comment"># trace</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;tracing..&quot;</span>)
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.<span class="hljs-built_in">eval</span>()
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;done tracing&quot;</span>)


<span class="hljs-comment"># warmup and optimize graph</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">5</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


<span class="hljs-comment"># benchmarking</span>
<span class="hljs-keyword">with</span> torch.inference_mode():
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet traced inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)

<span class="hljs-comment"># save the model</span>
unet_traced.save(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)`}}),Ke=new j({props:{code:`from diffusers import StableDiffusionPipeline
import torch
from dataclasses import dataclass


@dataclass
class UNet2DConditionOutput:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
).to("cuda")

# use jitted unet
unet_traced = torch.jit.load("unet_traced.pt")
# del pipe.unet
class TracedUNet(torch.nn.Module):
    def __init__(self):
        super().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    def forward(self, latent_model_input, t, encoder_hidden_states):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[0]
        return UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

with torch.inference_mode():
    image = pipe([prompt] * 1, num_inference_steps=50).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">UNet2DConditionOutput</span>:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># use jitted unet</span>
unet_traced = torch.jit.load(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)
<span class="hljs-comment"># del pipe.unet</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TracedUNet</span>(torch.nn.Module):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
        <span class="hljs-built_in">super</span>().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, latent_model_input, t, encoder_hidden_states</span>):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[<span class="hljs-number">0</span>]
        <span class="hljs-keyword">return</span> UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

<span class="hljs-keyword">with</span> torch.inference_mode():
    image = pipe([prompt] * <span class="hljs-number">1</span>, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]`}}),Qe=new T({}),et=new j({props:{code:`from diffusers import StableDiffusionPipeline
import torch

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    revision="fp16",
    torch_dtype=torch.float16,
).to("cuda")

pipe.enable_xformers_memory_efficient_attention()

with torch.inference_mode():
    sample = pipe("a small cat")

# optional: You can disable it via
# pipe.disable_xformers_memory_efficient_attention()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    revision=<span class="hljs-string">&quot;fp16&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-keyword">with</span> torch.inference_mode():
    sample = pipe(<span class="hljs-string">&quot;a small cat&quot;</span>)

<span class="hljs-comment"># optional: You can disable it via</span>
<span class="hljs-comment"># pipe.disable_xformers_memory_efficient_attention()</span>`}}),{c(){w=a("meta"),D=p(),k=a("h1"),ne=a("a"),Ft=a("span"),u(De.$$.fragment),Cn=p(),Mt=a("span"),Rn=r("Memory and speed"),da=p(),oe=a("p"),Fn=r("We present some techniques and ideas to optimize \u{1F917} Diffusers "),zt=a("em"),Mn=r("inference"),zn=r(" for memory or speed."),ma=p(),re=a("table"),Ht=a("thead"),S=a("tr"),_a=a("th"),Hn=p(),Vt=a("th"),Vn=r("Latency"),Gn=p(),Gt=a("th"),On=r("Speedup"),Bn=p(),b=a("tbody"),N=a("tr"),Ot=a("td"),Ln=r("original"),Xn=p(),Bt=a("td"),Yn=r("9.50s"),Wn=p(),Lt=a("td"),Kn=r("x1"),Qn=p(),U=a("tr"),Xt=a("td"),Jn=r("cuDNN auto-tuner"),Zn=p(),Yt=a("td"),eo=r("9.37s"),to=p(),Wt=a("td"),so=r("x1.01"),ao=p(),I=a("tr"),Kt=a("td"),no=r("autocast (fp16)"),oo=p(),Qt=a("td"),ro=r("5.47s"),io=p(),Jt=a("td"),lo=r("x1.74"),po=p(),C=a("tr"),Zt=a("td"),fo=r("fp16"),co=p(),es=a("td"),ho=r("3.61s"),uo=p(),ts=a("td"),mo=r("x2.63"),_o=p(),R=a("tr"),ss=a("td"),vo=r("channels last"),yo=p(),as=a("td"),bo=r("3.30s"),go=p(),ns=a("td"),wo=r("x2.88"),$o=p(),F=a("tr"),os=a("td"),Eo=r("traced UNet"),jo=p(),rs=a("td"),ko=r("3.21s"),To=p(),is=a("td"),Do=r("x2.96"),Ao=p(),M=a("tr"),ls=a("td"),Po=r("memory efficient attention"),qo=p(),ps=a("td"),xo=r("2.63s"),So=p(),fs=a("td"),No=r("x3.61"),va=p(),st=a("em"),Uo=r(`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),ya=p(),z=a("h2"),ie=a("a"),cs=a("span"),u(Ae.$$.fragment),Io=p(),hs=a("span"),Co=r("Enable cuDNN auto-tuner"),ba=p(),Pe=a("p"),qe=a("a"),Ro=r("NVIDIA cuDNN"),Fo=r("\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),ga=p(),le=a("p"),Mo=r("Since we\u2019re using "),us=a("strong"),zo=r("convolutional networks"),Ho=r(" (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),wa=p(),u(xe.$$.fragment),$a=p(),H=a("h3"),pe=a("a"),ds=a("span"),u(Se.$$.fragment),Vo=p(),ms=a("span"),Go=r("Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Ea=p(),fe=a("p"),Oo=r("On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Ne=a("a"),Bo=r("here"),Lo=r(". All you need to do is to add this before your inference:"),ja=p(),u(Ue.$$.fragment),ka=p(),V=a("h2"),ce=a("a"),_s=a("span"),u(Ie.$$.fragment),Xo=p(),vs=a("span"),Yo=r("Automatic mixed precision (AMP)"),Ta=p(),A=a("p"),Wo=r("If you use a CUDA GPU, you can take advantage of "),ys=a("code"),Ko=r("torch.autocast"),Qo=r(" to perform inference roughly twice as fast at the cost of slightly lower precision. All you need to do is put your inference call inside an "),bs=a("code"),Jo=r("autocast"),Zo=r(" context manager. The following example shows how to do it using Stable Diffusion text-to-image generation as an example:"),Da=p(),u(Ce.$$.fragment),Aa=p(),he=a("p"),er=r("Despite the precision loss, in our experience the final image results look the same as the "),gs=a("code"),tr=r("float32"),sr=r(" versions. Feel free to experiment and report back!"),Pa=p(),G=a("h2"),ue=a("a"),ws=a("span"),u(Re.$$.fragment),ar=p(),$s=a("span"),nr=r("Half precision weights"),qa=p(),P=a("p"),or=r("To save more GPU memory and get even more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Es=a("code"),rr=r("fp16"),ir=r(", and telling PyTorch to use the "),js=a("code"),lr=r("float16"),pr=r(" type when loading them:"),xa=p(),u(Fe.$$.fragment),Sa=p(),O=a("h2"),de=a("a"),ks=a("span"),u(Me.$$.fragment),fr=p(),Ts=a("span"),cr=r("Sliced attention for additional memory savings"),Na=p(),at=a("p"),hr=r("For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Ua=p(),u(me.$$.fragment),Ia=p(),_e=a("p"),ur=r("To perform the attention computation sequentially over each head, you only need to invoke "),nt=a("a"),dr=r("enable_attention_slicing()"),mr=r(" in your pipeline before inference, like here:"),Ca=p(),u(ze.$$.fragment),Ra=p(),ot=a("p"),_r=r("There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),Fa=p(),B=a("h2"),ve=a("a"),Ds=a("span"),u(He.$$.fragment),vr=p(),As=a("span"),yr=r("Sliced VAE decode for larger batches"),Ma=p(),rt=a("p"),br=r("To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),za=p(),q=a("p"),gr=r("You likely want to couple this with "),it=a("a"),wr=r("enable_attention_slicing()"),$r=r(" or "),lt=a("a"),Er=r("enable_xformers_memory_efficient_attention()"),jr=r(" to further minimize memory use."),Ha=p(),ye=a("p"),kr=r("To perform the VAE decode one image at a time, invoke "),pt=a("a"),Tr=r("enable_vae_slicing()"),Dr=r(" in your pipeline before inference. For example:"),Va=p(),u(Ve.$$.fragment),Ga=p(),ft=a("p"),Ar=r("You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),Oa=p(),L=a("h2"),be=a("a"),Ps=a("span"),u(Ge.$$.fragment),Pr=p(),qs=a("span"),qr=r("Offloading to CPU with accelerate for memory savings"),Ba=p(),ct=a("p"),xr=r("For additional memory savings, you can offload the weights to CPU and load them to GPU when performing the forward pass."),La=p(),ge=a("p"),Sr=r("To perform CPU offloading, all you have to do is invoke "),xs=a("code"),Nr=r("enable_sequential_cpu_offload()"),Ur=r(":"),Xa=p(),u(Oe.$$.fragment),Ya=p(),ht=a("p"),Ir=r("And you can get the memory consumption to < 2GB."),Wa=p(),ut=a("p"),Cr=r("If is also possible to chain it with attention slicing for minimal memory consumption, running it in as little as < 800mb of GPU vRAM:"),Ka=p(),u(Be.$$.fragment),Qa=p(),X=a("h2"),we=a("a"),Ss=a("span"),u(Le.$$.fragment),Rr=p(),Ns=a("span"),Fr=r("Using Channels Last memory format"),Ja=p(),dt=a("p"),Mr=r("Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),Za=p(),mt=a("p"),zr=r("For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),en=p(),u(Xe.$$.fragment),tn=p(),Y=a("h2"),$e=a("a"),Us=a("span"),u(Ye.$$.fragment),Hr=p(),Is=a("span"),Vr=r("Tracing"),sn=p(),Ee=a("p"),Gr=r("Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),Cs=a("code"),Or=r("ScriptFunction"),Br=r(" is returned that will be optimized using just-in-time compilation."),an=p(),_t=a("p"),Lr=r("To trace our UNet model, we can use the following:"),nn=p(),u(We.$$.fragment),on=p(),je=a("p"),Xr=r("Then we can replace the "),Rs=a("code"),Yr=r("unet"),Wr=r(" attribute of the pipeline with the traced model like the following"),rn=p(),u(Ke.$$.fragment),ln=p(),W=a("h2"),ke=a("a"),Fs=a("span"),u(Qe.$$.fragment),Kr=p(),Ms=a("span"),Qr=r("Memory Efficient Attention"),pn=r(`

Recent work on optimizing the bandwitdh in the attention block have generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention (from @tridao, [code](https://github.com/HazyResearch/flash-attention), [paper](https://arxiv.org/pdf/2205.14135.pdf)) .
Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):
`),Te=a("table"),zs=a("thead"),K=a("tr"),Hs=a("th"),Jr=r("GPU"),Zr=p(),Vs=a("th"),ei=r("Base Attention FP16"),ti=p(),Gs=a("th"),si=r("Memory Efficient Attention FP16"),ai=p(),g=a("tbody"),Q=a("tr"),Os=a("td"),ni=r("NVIDIA Tesla T4"),oi=p(),Bs=a("td"),ri=r("3.5it/s"),ii=p(),Ls=a("td"),li=r("5.5it/s"),pi=p(),J=a("tr"),Xs=a("td"),fi=r("NVIDIA 3060 RTX"),ci=p(),Ys=a("td"),hi=r("4.6it/s"),ui=p(),Ws=a("td"),di=r("7.8it/s"),mi=p(),Z=a("tr"),Ks=a("td"),_i=r("NVIDIA A10G"),vi=p(),Qs=a("td"),yi=r("8.88it/s"),bi=p(),Js=a("td"),gi=r("15.6it/s"),wi=p(),ee=a("tr"),Zs=a("td"),$i=r("NVIDIA RTX A6000"),Ei=p(),ea=a("td"),ji=r("11.7it/s"),ki=p(),ta=a("td"),Ti=r("21.09it/s"),Di=p(),te=a("tr"),sa=a("td"),Ai=r("NVIDIA TITAN RTX"),Pi=p(),aa=a("td"),qi=r("12.51it/s"),xi=p(),na=a("td"),Si=r("18.22it/s"),Ni=p(),se=a("tr"),oa=a("td"),Ui=r("A100-SXM4-40GB"),Ii=p(),ra=a("td"),Ci=r("18.6it/s"),Ri=p(),ia=a("td"),Fi=r("29.it/s"),Mi=p(),ae=a("tr"),la=a("td"),zi=r("A100-SXM-80GB"),Hi=p(),pa=a("td"),Vi=r("18.7it/s"),Gi=p(),fa=a("td"),Oi=r("29.5it/s"),fn=p(),vt=a("p"),Bi=r("To leverage it just make sure you have:"),cn=p(),x=a("ul"),ca=a("li"),Li=r("PyTorch > 1.12"),Xi=p(),ha=a("li"),Yi=r("Cuda available"),Wi=p(),Je=a("li"),Ki=r("Installed the "),Ze=a("a"),Qi=r("xformers"),Ji=r(" library"),hn=p(),u(et.$$.fragment),this.h()},l(e){const l=pf('[data-svelte="svelte-1phssyn"]',document.head);w=n(l,"META",{name:!0,content:!0}),l.forEach(s),D=f(e),k=n(e,"H1",{class:!0});var tt=o(k);ne=n(tt,"A",{id:!0,class:!0,href:!0});var el=o(ne);Ft=n(el,"SPAN",{});var tl=o(Ft);d(De.$$.fragment,tl),tl.forEach(s),el.forEach(s),Cn=f(tt),Mt=n(tt,"SPAN",{});var sl=o(Mt);Rn=i(sl,"Memory and speed"),sl.forEach(s),tt.forEach(s),da=f(e),oe=n(e,"P",{});var dn=o(oe);Fn=i(dn,"We present some techniques and ideas to optimize \u{1F917} Diffusers "),zt=n(dn,"EM",{});var al=o(zt);Mn=i(al,"inference"),al.forEach(s),zn=i(dn," for memory or speed."),dn.forEach(s),ma=f(e),re=n(e,"TABLE",{});var mn=o(re);Ht=n(mn,"THEAD",{});var nl=o(Ht);S=n(nl,"TR",{});var yt=o(S);_a=n(yt,"TH",{}),o(_a).forEach(s),Hn=f(yt),Vt=n(yt,"TH",{});var ol=o(Vt);Vn=i(ol,"Latency"),ol.forEach(s),Gn=f(yt),Gt=n(yt,"TH",{});var rl=o(Gt);On=i(rl,"Speedup"),rl.forEach(s),yt.forEach(s),nl.forEach(s),Bn=f(mn),b=n(mn,"TBODY",{});var $=o(b);N=n($,"TR",{});var bt=o(N);Ot=n(bt,"TD",{});var il=o(Ot);Ln=i(il,"original"),il.forEach(s),Xn=f(bt),Bt=n(bt,"TD",{});var ll=o(Bt);Yn=i(ll,"9.50s"),ll.forEach(s),Wn=f(bt),Lt=n(bt,"TD",{});var pl=o(Lt);Kn=i(pl,"x1"),pl.forEach(s),bt.forEach(s),Qn=f($),U=n($,"TR",{});var gt=o(U);Xt=n(gt,"TD",{});var fl=o(Xt);Jn=i(fl,"cuDNN auto-tuner"),fl.forEach(s),Zn=f(gt),Yt=n(gt,"TD",{});var cl=o(Yt);eo=i(cl,"9.37s"),cl.forEach(s),to=f(gt),Wt=n(gt,"TD",{});var hl=o(Wt);so=i(hl,"x1.01"),hl.forEach(s),gt.forEach(s),ao=f($),I=n($,"TR",{});var wt=o(I);Kt=n(wt,"TD",{});var ul=o(Kt);no=i(ul,"autocast (fp16)"),ul.forEach(s),oo=f(wt),Qt=n(wt,"TD",{});var dl=o(Qt);ro=i(dl,"5.47s"),dl.forEach(s),io=f(wt),Jt=n(wt,"TD",{});var ml=o(Jt);lo=i(ml,"x1.74"),ml.forEach(s),wt.forEach(s),po=f($),C=n($,"TR",{});var $t=o(C);Zt=n($t,"TD",{});var _l=o(Zt);fo=i(_l,"fp16"),_l.forEach(s),co=f($t),es=n($t,"TD",{});var vl=o(es);ho=i(vl,"3.61s"),vl.forEach(s),uo=f($t),ts=n($t,"TD",{});var yl=o(ts);mo=i(yl,"x2.63"),yl.forEach(s),$t.forEach(s),_o=f($),R=n($,"TR",{});var Et=o(R);ss=n(Et,"TD",{});var bl=o(ss);vo=i(bl,"channels last"),bl.forEach(s),yo=f(Et),as=n(Et,"TD",{});var gl=o(as);bo=i(gl,"3.30s"),gl.forEach(s),go=f(Et),ns=n(Et,"TD",{});var wl=o(ns);wo=i(wl,"x2.88"),wl.forEach(s),Et.forEach(s),$o=f($),F=n($,"TR",{});var jt=o(F);os=n(jt,"TD",{});var $l=o(os);Eo=i($l,"traced UNet"),$l.forEach(s),jo=f(jt),rs=n(jt,"TD",{});var El=o(rs);ko=i(El,"3.21s"),El.forEach(s),To=f(jt),is=n(jt,"TD",{});var jl=o(is);Do=i(jl,"x2.96"),jl.forEach(s),jt.forEach(s),Ao=f($),M=n($,"TR",{});var kt=o(M);ls=n(kt,"TD",{});var kl=o(ls);Po=i(kl,"memory efficient attention"),kl.forEach(s),qo=f(kt),ps=n(kt,"TD",{});var Tl=o(ps);xo=i(Tl,"2.63s"),Tl.forEach(s),So=f(kt),fs=n(kt,"TD",{});var Dl=o(fs);No=i(Dl,"x3.61"),Dl.forEach(s),kt.forEach(s),$.forEach(s),mn.forEach(s),va=f(e),st=n(e,"EM",{});var Al=o(st);Uo=i(Al,`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),Al.forEach(s),ya=f(e),z=n(e,"H2",{class:!0});var _n=o(z);ie=n(_n,"A",{id:!0,class:!0,href:!0});var Pl=o(ie);cs=n(Pl,"SPAN",{});var ql=o(cs);d(Ae.$$.fragment,ql),ql.forEach(s),Pl.forEach(s),Io=f(_n),hs=n(_n,"SPAN",{});var xl=o(hs);Co=i(xl,"Enable cuDNN auto-tuner"),xl.forEach(s),_n.forEach(s),ba=f(e),Pe=n(e,"P",{});var Zi=o(Pe);qe=n(Zi,"A",{href:!0,rel:!0});var Sl=o(qe);Ro=i(Sl,"NVIDIA cuDNN"),Sl.forEach(s),Fo=i(Zi,"\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),Zi.forEach(s),ga=f(e),le=n(e,"P",{});var vn=o(le);Mo=i(vn,"Since we\u2019re using "),us=n(vn,"STRONG",{});var Nl=o(us);zo=i(Nl,"convolutional networks"),Nl.forEach(s),Ho=i(vn," (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),vn.forEach(s),wa=f(e),d(xe.$$.fragment,e),$a=f(e),H=n(e,"H3",{class:!0});var yn=o(H);pe=n(yn,"A",{id:!0,class:!0,href:!0});var Ul=o(pe);ds=n(Ul,"SPAN",{});var Il=o(ds);d(Se.$$.fragment,Il),Il.forEach(s),Ul.forEach(s),Vo=f(yn),ms=n(yn,"SPAN",{});var Cl=o(ms);Go=i(Cl,"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Cl.forEach(s),yn.forEach(s),Ea=f(e),fe=n(e,"P",{});var bn=o(fe);Oo=i(bn,"On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Ne=n(bn,"A",{href:!0,rel:!0});var Rl=o(Ne);Bo=i(Rl,"here"),Rl.forEach(s),Lo=i(bn,". All you need to do is to add this before your inference:"),bn.forEach(s),ja=f(e),d(Ue.$$.fragment,e),ka=f(e),V=n(e,"H2",{class:!0});var gn=o(V);ce=n(gn,"A",{id:!0,class:!0,href:!0});var Fl=o(ce);_s=n(Fl,"SPAN",{});var Ml=o(_s);d(Ie.$$.fragment,Ml),Ml.forEach(s),Fl.forEach(s),Xo=f(gn),vs=n(gn,"SPAN",{});var zl=o(vs);Yo=i(zl,"Automatic mixed precision (AMP)"),zl.forEach(s),gn.forEach(s),Ta=f(e),A=n(e,"P",{});var Tt=o(A);Wo=i(Tt,"If you use a CUDA GPU, you can take advantage of "),ys=n(Tt,"CODE",{});var Hl=o(ys);Ko=i(Hl,"torch.autocast"),Hl.forEach(s),Qo=i(Tt," to perform inference roughly twice as fast at the cost of slightly lower precision. All you need to do is put your inference call inside an "),bs=n(Tt,"CODE",{});var Vl=o(bs);Jo=i(Vl,"autocast"),Vl.forEach(s),Zo=i(Tt," context manager. The following example shows how to do it using Stable Diffusion text-to-image generation as an example:"),Tt.forEach(s),Da=f(e),d(Ce.$$.fragment,e),Aa=f(e),he=n(e,"P",{});var wn=o(he);er=i(wn,"Despite the precision loss, in our experience the final image results look the same as the "),gs=n(wn,"CODE",{});var Gl=o(gs);tr=i(Gl,"float32"),Gl.forEach(s),sr=i(wn," versions. Feel free to experiment and report back!"),wn.forEach(s),Pa=f(e),G=n(e,"H2",{class:!0});var $n=o(G);ue=n($n,"A",{id:!0,class:!0,href:!0});var Ol=o(ue);ws=n(Ol,"SPAN",{});var Bl=o(ws);d(Re.$$.fragment,Bl),Bl.forEach(s),Ol.forEach(s),ar=f($n),$s=n($n,"SPAN",{});var Ll=o($s);nr=i(Ll,"Half precision weights"),Ll.forEach(s),$n.forEach(s),qa=f(e),P=n(e,"P",{});var Dt=o(P);or=i(Dt,"To save more GPU memory and get even more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Es=n(Dt,"CODE",{});var Xl=o(Es);rr=i(Xl,"fp16"),Xl.forEach(s),ir=i(Dt,", and telling PyTorch to use the "),js=n(Dt,"CODE",{});var Yl=o(js);lr=i(Yl,"float16"),Yl.forEach(s),pr=i(Dt," type when loading them:"),Dt.forEach(s),xa=f(e),d(Fe.$$.fragment,e),Sa=f(e),O=n(e,"H2",{class:!0});var En=o(O);de=n(En,"A",{id:!0,class:!0,href:!0});var Wl=o(de);ks=n(Wl,"SPAN",{});var Kl=o(ks);d(Me.$$.fragment,Kl),Kl.forEach(s),Wl.forEach(s),fr=f(En),Ts=n(En,"SPAN",{});var Ql=o(Ts);cr=i(Ql,"Sliced attention for additional memory savings"),Ql.forEach(s),En.forEach(s),Na=f(e),at=n(e,"P",{});var Jl=o(at);hr=i(Jl,"For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Jl.forEach(s),Ua=f(e),d(me.$$.fragment,e),Ia=f(e),_e=n(e,"P",{});var jn=o(_e);ur=i(jn,"To perform the attention computation sequentially over each head, you only need to invoke "),nt=n(jn,"A",{href:!0});var Zl=o(nt);dr=i(Zl,"enable_attention_slicing()"),Zl.forEach(s),mr=i(jn," in your pipeline before inference, like here:"),jn.forEach(s),Ca=f(e),d(ze.$$.fragment,e),Ra=f(e),ot=n(e,"P",{});var ep=o(ot);_r=i(ep,"There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),ep.forEach(s),Fa=f(e),B=n(e,"H2",{class:!0});var kn=o(B);ve=n(kn,"A",{id:!0,class:!0,href:!0});var tp=o(ve);Ds=n(tp,"SPAN",{});var sp=o(Ds);d(He.$$.fragment,sp),sp.forEach(s),tp.forEach(s),vr=f(kn),As=n(kn,"SPAN",{});var ap=o(As);yr=i(ap,"Sliced VAE decode for larger batches"),ap.forEach(s),kn.forEach(s),Ma=f(e),rt=n(e,"P",{});var np=o(rt);br=i(np,"To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),np.forEach(s),za=f(e),q=n(e,"P",{});var At=o(q);gr=i(At,"You likely want to couple this with "),it=n(At,"A",{href:!0});var op=o(it);wr=i(op,"enable_attention_slicing()"),op.forEach(s),$r=i(At," or "),lt=n(At,"A",{href:!0});var rp=o(lt);Er=i(rp,"enable_xformers_memory_efficient_attention()"),rp.forEach(s),jr=i(At," to further minimize memory use."),At.forEach(s),Ha=f(e),ye=n(e,"P",{});var Tn=o(ye);kr=i(Tn,"To perform the VAE decode one image at a time, invoke "),pt=n(Tn,"A",{href:!0});var ip=o(pt);Tr=i(ip,"enable_vae_slicing()"),ip.forEach(s),Dr=i(Tn," in your pipeline before inference. For example:"),Tn.forEach(s),Va=f(e),d(Ve.$$.fragment,e),Ga=f(e),ft=n(e,"P",{});var lp=o(ft);Ar=i(lp,"You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),lp.forEach(s),Oa=f(e),L=n(e,"H2",{class:!0});var Dn=o(L);be=n(Dn,"A",{id:!0,class:!0,href:!0});var pp=o(be);Ps=n(pp,"SPAN",{});var fp=o(Ps);d(Ge.$$.fragment,fp),fp.forEach(s),pp.forEach(s),Pr=f(Dn),qs=n(Dn,"SPAN",{});var cp=o(qs);qr=i(cp,"Offloading to CPU with accelerate for memory savings"),cp.forEach(s),Dn.forEach(s),Ba=f(e),ct=n(e,"P",{});var hp=o(ct);xr=i(hp,"For additional memory savings, you can offload the weights to CPU and load them to GPU when performing the forward pass."),hp.forEach(s),La=f(e),ge=n(e,"P",{});var An=o(ge);Sr=i(An,"To perform CPU offloading, all you have to do is invoke "),xs=n(An,"CODE",{});var up=o(xs);Nr=i(up,"enable_sequential_cpu_offload()"),up.forEach(s),Ur=i(An,":"),An.forEach(s),Xa=f(e),d(Oe.$$.fragment,e),Ya=f(e),ht=n(e,"P",{});var dp=o(ht);Ir=i(dp,"And you can get the memory consumption to < 2GB."),dp.forEach(s),Wa=f(e),ut=n(e,"P",{});var mp=o(ut);Cr=i(mp,"If is also possible to chain it with attention slicing for minimal memory consumption, running it in as little as < 800mb of GPU vRAM:"),mp.forEach(s),Ka=f(e),d(Be.$$.fragment,e),Qa=f(e),X=n(e,"H2",{class:!0});var Pn=o(X);we=n(Pn,"A",{id:!0,class:!0,href:!0});var _p=o(we);Ss=n(_p,"SPAN",{});var vp=o(Ss);d(Le.$$.fragment,vp),vp.forEach(s),_p.forEach(s),Rr=f(Pn),Ns=n(Pn,"SPAN",{});var yp=o(Ns);Fr=i(yp,"Using Channels Last memory format"),yp.forEach(s),Pn.forEach(s),Ja=f(e),dt=n(e,"P",{});var bp=o(dt);Mr=i(bp,"Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),bp.forEach(s),Za=f(e),mt=n(e,"P",{});var gp=o(mt);zr=i(gp,"For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),gp.forEach(s),en=f(e),d(Xe.$$.fragment,e),tn=f(e),Y=n(e,"H2",{class:!0});var qn=o(Y);$e=n(qn,"A",{id:!0,class:!0,href:!0});var wp=o($e);Us=n(wp,"SPAN",{});var $p=o(Us);d(Ye.$$.fragment,$p),$p.forEach(s),wp.forEach(s),Hr=f(qn),Is=n(qn,"SPAN",{});var Ep=o(Is);Vr=i(Ep,"Tracing"),Ep.forEach(s),qn.forEach(s),sn=f(e),Ee=n(e,"P",{});var xn=o(Ee);Gr=i(xn,"Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),Cs=n(xn,"CODE",{});var jp=o(Cs);Or=i(jp,"ScriptFunction"),jp.forEach(s),Br=i(xn," is returned that will be optimized using just-in-time compilation."),xn.forEach(s),an=f(e),_t=n(e,"P",{});var kp=o(_t);Lr=i(kp,"To trace our UNet model, we can use the following:"),kp.forEach(s),nn=f(e),d(We.$$.fragment,e),on=f(e),je=n(e,"P",{});var Sn=o(je);Xr=i(Sn,"Then we can replace the "),Rs=n(Sn,"CODE",{});var Tp=o(Rs);Yr=i(Tp,"unet"),Tp.forEach(s),Wr=i(Sn," attribute of the pipeline with the traced model like the following"),Sn.forEach(s),rn=f(e),d(Ke.$$.fragment,e),ln=f(e),W=n(e,"H2",{class:!0});var Nn=o(W);ke=n(Nn,"A",{id:!0,class:!0,href:!0});var Dp=o(ke);Fs=n(Dp,"SPAN",{});var Ap=o(Fs);d(Qe.$$.fragment,Ap),Ap.forEach(s),Dp.forEach(s),Kr=f(Nn),Ms=n(Nn,"SPAN",{});var Pp=o(Ms);Qr=i(Pp,"Memory Efficient Attention"),Pp.forEach(s),Nn.forEach(s),pn=i(e,`

Recent work on optimizing the bandwitdh in the attention block have generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention (from @tridao, [code](https://github.com/HazyResearch/flash-attention), [paper](https://arxiv.org/pdf/2205.14135.pdf)) .
Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):
`),Te=n(e,"TABLE",{});var Un=o(Te);zs=n(Un,"THEAD",{});var qp=o(zs);K=n(qp,"TR",{});var Pt=o(K);Hs=n(Pt,"TH",{});var xp=o(Hs);Jr=i(xp,"GPU"),xp.forEach(s),Zr=f(Pt),Vs=n(Pt,"TH",{});var Sp=o(Vs);ei=i(Sp,"Base Attention FP16"),Sp.forEach(s),ti=f(Pt),Gs=n(Pt,"TH",{});var Np=o(Gs);si=i(Np,"Memory Efficient Attention FP16"),Np.forEach(s),Pt.forEach(s),qp.forEach(s),ai=f(Un),g=n(Un,"TBODY",{});var E=o(g);Q=n(E,"TR",{});var qt=o(Q);Os=n(qt,"TD",{});var Up=o(Os);ni=i(Up,"NVIDIA Tesla T4"),Up.forEach(s),oi=f(qt),Bs=n(qt,"TD",{});var Ip=o(Bs);ri=i(Ip,"3.5it/s"),Ip.forEach(s),ii=f(qt),Ls=n(qt,"TD",{});var Cp=o(Ls);li=i(Cp,"5.5it/s"),Cp.forEach(s),qt.forEach(s),pi=f(E),J=n(E,"TR",{});var xt=o(J);Xs=n(xt,"TD",{});var Rp=o(Xs);fi=i(Rp,"NVIDIA 3060 RTX"),Rp.forEach(s),ci=f(xt),Ys=n(xt,"TD",{});var Fp=o(Ys);hi=i(Fp,"4.6it/s"),Fp.forEach(s),ui=f(xt),Ws=n(xt,"TD",{});var Mp=o(Ws);di=i(Mp,"7.8it/s"),Mp.forEach(s),xt.forEach(s),mi=f(E),Z=n(E,"TR",{});var St=o(Z);Ks=n(St,"TD",{});var zp=o(Ks);_i=i(zp,"NVIDIA A10G"),zp.forEach(s),vi=f(St),Qs=n(St,"TD",{});var Hp=o(Qs);yi=i(Hp,"8.88it/s"),Hp.forEach(s),bi=f(St),Js=n(St,"TD",{});var Vp=o(Js);gi=i(Vp,"15.6it/s"),Vp.forEach(s),St.forEach(s),wi=f(E),ee=n(E,"TR",{});var Nt=o(ee);Zs=n(Nt,"TD",{});var Gp=o(Zs);$i=i(Gp,"NVIDIA RTX A6000"),Gp.forEach(s),Ei=f(Nt),ea=n(Nt,"TD",{});var Op=o(ea);ji=i(Op,"11.7it/s"),Op.forEach(s),ki=f(Nt),ta=n(Nt,"TD",{});var Bp=o(ta);Ti=i(Bp,"21.09it/s"),Bp.forEach(s),Nt.forEach(s),Di=f(E),te=n(E,"TR",{});var Ut=o(te);sa=n(Ut,"TD",{});var Lp=o(sa);Ai=i(Lp,"NVIDIA TITAN RTX"),Lp.forEach(s),Pi=f(Ut),aa=n(Ut,"TD",{});var Xp=o(aa);qi=i(Xp,"12.51it/s"),Xp.forEach(s),xi=f(Ut),na=n(Ut,"TD",{});var Yp=o(na);Si=i(Yp,"18.22it/s"),Yp.forEach(s),Ut.forEach(s),Ni=f(E),se=n(E,"TR",{});var It=o(se);oa=n(It,"TD",{});var Wp=o(oa);Ui=i(Wp,"A100-SXM4-40GB"),Wp.forEach(s),Ii=f(It),ra=n(It,"TD",{});var Kp=o(ra);Ci=i(Kp,"18.6it/s"),Kp.forEach(s),Ri=f(It),ia=n(It,"TD",{});var Qp=o(ia);Fi=i(Qp,"29.it/s"),Qp.forEach(s),It.forEach(s),Mi=f(E),ae=n(E,"TR",{});var Ct=o(ae);la=n(Ct,"TD",{});var Jp=o(la);zi=i(Jp,"A100-SXM-80GB"),Jp.forEach(s),Hi=f(Ct),pa=n(Ct,"TD",{});var Zp=o(pa);Vi=i(Zp,"18.7it/s"),Zp.forEach(s),Gi=f(Ct),fa=n(Ct,"TD",{});var ef=o(fa);Oi=i(ef,"29.5it/s"),ef.forEach(s),Ct.forEach(s),E.forEach(s),Un.forEach(s),fn=f(e),vt=n(e,"P",{});var tf=o(vt);Bi=i(tf,"To leverage it just make sure you have:"),tf.forEach(s),cn=f(e),x=n(e,"UL",{});var Rt=o(x);ca=n(Rt,"LI",{});var sf=o(ca);Li=i(sf,"PyTorch > 1.12"),sf.forEach(s),Xi=f(Rt),ha=n(Rt,"LI",{});var af=o(ha);Yi=i(af,"Cuda available"),af.forEach(s),Wi=f(Rt),Je=n(Rt,"LI",{});var In=o(Je);Ki=i(In,"Installed the "),Ze=n(In,"A",{href:!0,rel:!0});var nf=o(Ze);Qi=i(nf,"xformers"),nf.forEach(s),Ji=i(In," library"),In.forEach(s),Rt.forEach(s),hn=f(e),d(et.$$.fragment,e),this.h()},h(){h(w,"name","hf:doc:metadata"),h(w,"content",JSON.stringify(df)),h(ne,"id","memory-and-speed"),h(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ne,"href","#memory-and-speed"),h(k,"class","relative group"),h(ie,"id","enable-cudnn-autotuner"),h(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ie,"href","#enable-cudnn-autotuner"),h(z,"class","relative group"),h(qe,"href","https://developer.nvidia.com/cudnn"),h(qe,"rel","nofollow"),h(pe,"id","use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(pe,"href","#use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(H,"class","relative group"),h(Ne,"href","https://huggingface.co/docs/transformers/v4.18.0/en/performance#tf32"),h(Ne,"rel","nofollow"),h(ce,"id","automatic-mixed-precision-amp"),h(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ce,"href","#automatic-mixed-precision-amp"),h(V,"class","relative group"),h(ue,"id","half-precision-weights"),h(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ue,"href","#half-precision-weights"),h(G,"class","relative group"),h(de,"id","sliced-attention-for-additional-memory-savings"),h(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(de,"href","#sliced-attention-for-additional-memory-savings"),h(O,"class","relative group"),h(nt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionPipeline.enable_attention_slicing"),h(ve,"id","sliced-vae-decode-for-larger-batches"),h(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ve,"href","#sliced-vae-decode-for-larger-batches"),h(B,"class","relative group"),h(it,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionPipeline.enable_attention_slicing"),h(lt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionUpscalePipeline.enable_xformers_memory_efficient_attention"),h(pt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionPipeline.enable_vae_slicing"),h(be,"id","offloading-to-cpu-with-accelerate-for-memory-savings"),h(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(be,"href","#offloading-to-cpu-with-accelerate-for-memory-savings"),h(L,"class","relative group"),h(we,"id","using-channels-last-memory-format"),h(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(we,"href","#using-channels-last-memory-format"),h(X,"class","relative group"),h($e,"id","tracing"),h($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h($e,"href","#tracing"),h(Y,"class","relative group"),h(ke,"id","memory-efficient-attention"),h(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ke,"href","#memory-efficient-attention"),h(W,"class","relative group"),h(Ze,"href","https://github.com/facebookresearch/xformers"),h(Ze,"rel","nofollow")},m(e,l){t(document.head,w),c(e,D,l),c(e,k,l),t(k,ne),t(ne,Ft),m(De,Ft,null),t(k,Cn),t(k,Mt),t(Mt,Rn),c(e,da,l),c(e,oe,l),t(oe,Fn),t(oe,zt),t(zt,Mn),t(oe,zn),c(e,ma,l),c(e,re,l),t(re,Ht),t(Ht,S),t(S,_a),t(S,Hn),t(S,Vt),t(Vt,Vn),t(S,Gn),t(S,Gt),t(Gt,On),t(re,Bn),t(re,b),t(b,N),t(N,Ot),t(Ot,Ln),t(N,Xn),t(N,Bt),t(Bt,Yn),t(N,Wn),t(N,Lt),t(Lt,Kn),t(b,Qn),t(b,U),t(U,Xt),t(Xt,Jn),t(U,Zn),t(U,Yt),t(Yt,eo),t(U,to),t(U,Wt),t(Wt,so),t(b,ao),t(b,I),t(I,Kt),t(Kt,no),t(I,oo),t(I,Qt),t(Qt,ro),t(I,io),t(I,Jt),t(Jt,lo),t(b,po),t(b,C),t(C,Zt),t(Zt,fo),t(C,co),t(C,es),t(es,ho),t(C,uo),t(C,ts),t(ts,mo),t(b,_o),t(b,R),t(R,ss),t(ss,vo),t(R,yo),t(R,as),t(as,bo),t(R,go),t(R,ns),t(ns,wo),t(b,$o),t(b,F),t(F,os),t(os,Eo),t(F,jo),t(F,rs),t(rs,ko),t(F,To),t(F,is),t(is,Do),t(b,Ao),t(b,M),t(M,ls),t(ls,Po),t(M,qo),t(M,ps),t(ps,xo),t(M,So),t(M,fs),t(fs,No),c(e,va,l),c(e,st,l),t(st,Uo),c(e,ya,l),c(e,z,l),t(z,ie),t(ie,cs),m(Ae,cs,null),t(z,Io),t(z,hs),t(hs,Co),c(e,ba,l),c(e,Pe,l),t(Pe,qe),t(qe,Ro),t(Pe,Fo),c(e,ga,l),c(e,le,l),t(le,Mo),t(le,us),t(us,zo),t(le,Ho),c(e,wa,l),m(xe,e,l),c(e,$a,l),c(e,H,l),t(H,pe),t(pe,ds),m(Se,ds,null),t(H,Vo),t(H,ms),t(ms,Go),c(e,Ea,l),c(e,fe,l),t(fe,Oo),t(fe,Ne),t(Ne,Bo),t(fe,Lo),c(e,ja,l),m(Ue,e,l),c(e,ka,l),c(e,V,l),t(V,ce),t(ce,_s),m(Ie,_s,null),t(V,Xo),t(V,vs),t(vs,Yo),c(e,Ta,l),c(e,A,l),t(A,Wo),t(A,ys),t(ys,Ko),t(A,Qo),t(A,bs),t(bs,Jo),t(A,Zo),c(e,Da,l),m(Ce,e,l),c(e,Aa,l),c(e,he,l),t(he,er),t(he,gs),t(gs,tr),t(he,sr),c(e,Pa,l),c(e,G,l),t(G,ue),t(ue,ws),m(Re,ws,null),t(G,ar),t(G,$s),t($s,nr),c(e,qa,l),c(e,P,l),t(P,or),t(P,Es),t(Es,rr),t(P,ir),t(P,js),t(js,lr),t(P,pr),c(e,xa,l),m(Fe,e,l),c(e,Sa,l),c(e,O,l),t(O,de),t(de,ks),m(Me,ks,null),t(O,fr),t(O,Ts),t(Ts,cr),c(e,Na,l),c(e,at,l),t(at,hr),c(e,Ua,l),m(me,e,l),c(e,Ia,l),c(e,_e,l),t(_e,ur),t(_e,nt),t(nt,dr),t(_e,mr),c(e,Ca,l),m(ze,e,l),c(e,Ra,l),c(e,ot,l),t(ot,_r),c(e,Fa,l),c(e,B,l),t(B,ve),t(ve,Ds),m(He,Ds,null),t(B,vr),t(B,As),t(As,yr),c(e,Ma,l),c(e,rt,l),t(rt,br),c(e,za,l),c(e,q,l),t(q,gr),t(q,it),t(it,wr),t(q,$r),t(q,lt),t(lt,Er),t(q,jr),c(e,Ha,l),c(e,ye,l),t(ye,kr),t(ye,pt),t(pt,Tr),t(ye,Dr),c(e,Va,l),m(Ve,e,l),c(e,Ga,l),c(e,ft,l),t(ft,Ar),c(e,Oa,l),c(e,L,l),t(L,be),t(be,Ps),m(Ge,Ps,null),t(L,Pr),t(L,qs),t(qs,qr),c(e,Ba,l),c(e,ct,l),t(ct,xr),c(e,La,l),c(e,ge,l),t(ge,Sr),t(ge,xs),t(xs,Nr),t(ge,Ur),c(e,Xa,l),m(Oe,e,l),c(e,Ya,l),c(e,ht,l),t(ht,Ir),c(e,Wa,l),c(e,ut,l),t(ut,Cr),c(e,Ka,l),m(Be,e,l),c(e,Qa,l),c(e,X,l),t(X,we),t(we,Ss),m(Le,Ss,null),t(X,Rr),t(X,Ns),t(Ns,Fr),c(e,Ja,l),c(e,dt,l),t(dt,Mr),c(e,Za,l),c(e,mt,l),t(mt,zr),c(e,en,l),m(Xe,e,l),c(e,tn,l),c(e,Y,l),t(Y,$e),t($e,Us),m(Ye,Us,null),t(Y,Hr),t(Y,Is),t(Is,Vr),c(e,sn,l),c(e,Ee,l),t(Ee,Gr),t(Ee,Cs),t(Cs,Or),t(Ee,Br),c(e,an,l),c(e,_t,l),t(_t,Lr),c(e,nn,l),m(We,e,l),c(e,on,l),c(e,je,l),t(je,Xr),t(je,Rs),t(Rs,Yr),t(je,Wr),c(e,rn,l),m(Ke,e,l),c(e,ln,l),c(e,W,l),t(W,ke),t(ke,Fs),m(Qe,Fs,null),t(W,Kr),t(W,Ms),t(Ms,Qr),c(e,pn,l),c(e,Te,l),t(Te,zs),t(zs,K),t(K,Hs),t(Hs,Jr),t(K,Zr),t(K,Vs),t(Vs,ei),t(K,ti),t(K,Gs),t(Gs,si),t(Te,ai),t(Te,g),t(g,Q),t(Q,Os),t(Os,ni),t(Q,oi),t(Q,Bs),t(Bs,ri),t(Q,ii),t(Q,Ls),t(Ls,li),t(g,pi),t(g,J),t(J,Xs),t(Xs,fi),t(J,ci),t(J,Ys),t(Ys,hi),t(J,ui),t(J,Ws),t(Ws,di),t(g,mi),t(g,Z),t(Z,Ks),t(Ks,_i),t(Z,vi),t(Z,Qs),t(Qs,yi),t(Z,bi),t(Z,Js),t(Js,gi),t(g,wi),t(g,ee),t(ee,Zs),t(Zs,$i),t(ee,Ei),t(ee,ea),t(ea,ji),t(ee,ki),t(ee,ta),t(ta,Ti),t(g,Di),t(g,te),t(te,sa),t(sa,Ai),t(te,Pi),t(te,aa),t(aa,qi),t(te,xi),t(te,na),t(na,Si),t(g,Ni),t(g,se),t(se,oa),t(oa,Ui),t(se,Ii),t(se,ra),t(ra,Ci),t(se,Ri),t(se,ia),t(ia,Fi),t(g,Mi),t(g,ae),t(ae,la),t(la,zi),t(ae,Hi),t(ae,pa),t(pa,Vi),t(ae,Gi),t(ae,fa),t(fa,Oi),c(e,fn,l),c(e,vt,l),t(vt,Bi),c(e,cn,l),c(e,x,l),t(x,ca),t(ca,Li),t(x,Xi),t(x,ha),t(ha,Yi),t(x,Wi),t(x,Je),t(Je,Ki),t(Je,Ze),t(Ze,Qi),t(Je,Ji),c(e,hn,l),m(et,e,l),un=!0},p(e,[l]){const tt={};l&2&&(tt.$$scope={dirty:l,ctx:e}),me.$set(tt)},i(e){un||(_(De.$$.fragment,e),_(Ae.$$.fragment,e),_(xe.$$.fragment,e),_(Se.$$.fragment,e),_(Ue.$$.fragment,e),_(Ie.$$.fragment,e),_(Ce.$$.fragment,e),_(Re.$$.fragment,e),_(Fe.$$.fragment,e),_(Me.$$.fragment,e),_(me.$$.fragment,e),_(ze.$$.fragment,e),_(He.$$.fragment,e),_(Ve.$$.fragment,e),_(Ge.$$.fragment,e),_(Oe.$$.fragment,e),_(Be.$$.fragment,e),_(Le.$$.fragment,e),_(Xe.$$.fragment,e),_(Ye.$$.fragment,e),_(We.$$.fragment,e),_(Ke.$$.fragment,e),_(Qe.$$.fragment,e),_(et.$$.fragment,e),un=!0)},o(e){v(De.$$.fragment,e),v(Ae.$$.fragment,e),v(xe.$$.fragment,e),v(Se.$$.fragment,e),v(Ue.$$.fragment,e),v(Ie.$$.fragment,e),v(Ce.$$.fragment,e),v(Re.$$.fragment,e),v(Fe.$$.fragment,e),v(Me.$$.fragment,e),v(me.$$.fragment,e),v(ze.$$.fragment,e),v(He.$$.fragment,e),v(Ve.$$.fragment,e),v(Ge.$$.fragment,e),v(Oe.$$.fragment,e),v(Be.$$.fragment,e),v(Le.$$.fragment,e),v(Xe.$$.fragment,e),v(Ye.$$.fragment,e),v(We.$$.fragment,e),v(Ke.$$.fragment,e),v(Qe.$$.fragment,e),v(et.$$.fragment,e),un=!1},d(e){s(w),e&&s(D),e&&s(k),y(De),e&&s(da),e&&s(oe),e&&s(ma),e&&s(re),e&&s(va),e&&s(st),e&&s(ya),e&&s(z),y(Ae),e&&s(ba),e&&s(Pe),e&&s(ga),e&&s(le),e&&s(wa),y(xe,e),e&&s($a),e&&s(H),y(Se),e&&s(Ea),e&&s(fe),e&&s(ja),y(Ue,e),e&&s(ka),e&&s(V),y(Ie),e&&s(Ta),e&&s(A),e&&s(Da),y(Ce,e),e&&s(Aa),e&&s(he),e&&s(Pa),e&&s(G),y(Re),e&&s(qa),e&&s(P),e&&s(xa),y(Fe,e),e&&s(Sa),e&&s(O),y(Me),e&&s(Na),e&&s(at),e&&s(Ua),y(me,e),e&&s(Ia),e&&s(_e),e&&s(Ca),y(ze,e),e&&s(Ra),e&&s(ot),e&&s(Fa),e&&s(B),y(He),e&&s(Ma),e&&s(rt),e&&s(za),e&&s(q),e&&s(Ha),e&&s(ye),e&&s(Va),y(Ve,e),e&&s(Ga),e&&s(ft),e&&s(Oa),e&&s(L),y(Ge),e&&s(Ba),e&&s(ct),e&&s(La),e&&s(ge),e&&s(Xa),y(Oe,e),e&&s(Ya),e&&s(ht),e&&s(Wa),e&&s(ut),e&&s(Ka),y(Be,e),e&&s(Qa),e&&s(X),y(Le),e&&s(Ja),e&&s(dt),e&&s(Za),e&&s(mt),e&&s(en),y(Xe,e),e&&s(tn),e&&s(Y),y(Ye),e&&s(sn),e&&s(Ee),e&&s(an),e&&s(_t),e&&s(nn),y(We,e),e&&s(on),e&&s(je),e&&s(rn),y(Ke,e),e&&s(ln),e&&s(W),y(Qe),e&&s(pn),e&&s(Te),e&&s(fn),e&&s(vt),e&&s(cn),e&&s(x),e&&s(hn),y(et,e)}}}const df={local:"memory-and-speed",sections:[{local:"enable-cudnn-autotuner",sections:[{local:"use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices",title:"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"}],title:"Enable cuDNN auto-tuner"},{local:"automatic-mixed-precision-amp",title:"Automatic mixed precision (AMP)"},{local:"half-precision-weights",title:"Half precision weights"},{local:"sliced-attention-for-additional-memory-savings",title:"Sliced attention for additional memory savings"},{local:"sliced-vae-decode-for-larger-batches",title:"Sliced VAE decode for larger batches"},{local:"offloading-to-cpu-with-accelerate-for-memory-savings",title:"Offloading to CPU with accelerate for memory savings"},{local:"using-channels-last-memory-format",title:"Using Channels Last memory format"},{local:"tracing",title:"Tracing"},{local:"memory-efficient-attention",title:"Memory Efficient Attention"}],title:"Memory and speed"};function mf(ua){return ff(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gf extends of{constructor(w){super();rf(this,w,mf,uf,lf,{})}}export{gf as default,df as metadata};
