import{S as va,i as wa,s as ya,e as l,k as u,w as k,t as i,M as Sa,c as r,d as t,m as h,a as o,x,h as a,b as n,G as e,g as f,y as A,L as Ea,q as M,o as L,B as N,v as Da}from"../../../chunks/vendor-hf-doc-builder.js";import{I as Ms}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ls}from"../../../chunks/CodeBlock-hf-doc-builder.js";function ja(_i){let v,rs,w,T,Be,R,Ls,Ce,Ns,os,m,Ts,He,Os,Us,z,Bs,Cs,V,Hs,Fs,Y,Rs,zs,ns,pe,y,Vs,G,Ys,Gs,Q,Qs,Ws,ps,O,Ks,W,Js,Xs,fs,S,U,Fe,K,Zs,Re,et,us,E,B,ze,J,st,Ve,tt,hs,_,it,fe,at,lt,ue,rt,ot,cs,g,D,Ye,nt,pt,X,ft,ut,he,ht,ct,j,Ge,dt,mt,Z,gt,_t,ce,bt,vt,I,Qe,wt,yt,ee,St,Et,de,Dt,jt,P,We,It,Pt,se,qt,$t,me,kt,ds,C,xt,ge,At,Mt,ms,_e,be,Ke,Lt,Nt,gs,te,_s,ve,we,Je,Tt,Ot,bs,ie,vs,ye,Se,Xe,Ut,Bt,ws,ae,ys,Ee,q,Ze,Ct,Ht,le,Ft,Rt,De,zt,Ss,re,Es,$,H,es,oe,Vt,ss,Yt,Ds,c,Gt,je,Qt,Wt,ts,Kt,Jt,Ie,Xt,Zt,Pe,ei,si,qe,ti,ii,$e,ai,li,ke,ri,oi,is,ni,pi,as,fi,ui,xe,hi,ci,js,ne,Is;return R=new Ms({}),K=new Ms({}),J=new Ms({}),te=new ls({props:{code:`from diffusers import DiffusionPipeline, DPMSolverMultistepScheduler
import torch

repo_id = "stabilityai/stable-diffusion-2-base"
pipe = DiffusionPipeline.from_pretrained(repo_id, torch_dtype=torch.float16, revision="fp16")

pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to("cuda")

prompt = "High quality photo of an astronaut riding a horse in space"
image = pipe(prompt, num_inference_steps=25).images[0]
image.save("astronaut.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline, DPMSolverMultistepScheduler
<span class="hljs-keyword">import</span> torch

repo_id = <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-base&quot;</span>
pipe = DiffusionPipeline.from_pretrained(repo_id, torch_dtype=torch.float16, revision=<span class="hljs-string">&quot;fp16&quot;</span>)

pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;High quality photo of an astronaut riding a horse in space&quot;</span>
image = pipe(prompt, num_inference_steps=<span class="hljs-number">25</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;astronaut.png&quot;</span>)`}}),ie=new ls({props:{code:`from diffusers import DiffusionPipeline, DPMSolverMultistepScheduler
import torch

repo_id = "stabilityai/stable-diffusion-2"
pipe = DiffusionPipeline.from_pretrained(repo_id, torch_dtype=torch.float16, revision="fp16")

pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to("cuda")

prompt = "High quality photo of an astronaut riding a horse in space"
image = pipe(prompt, guidance_scale=9, num_inference_steps=25).images[0]
image.save("astronaut.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline, DPMSolverMultistepScheduler
<span class="hljs-keyword">import</span> torch

repo_id = <span class="hljs-string">&quot;stabilityai/stable-diffusion-2&quot;</span>
pipe = DiffusionPipeline.from_pretrained(repo_id, torch_dtype=torch.float16, revision=<span class="hljs-string">&quot;fp16&quot;</span>)

pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;High quality photo of an astronaut riding a horse in space&quot;</span>
image = pipe(prompt, guidance_scale=<span class="hljs-number">9</span>, num_inference_steps=<span class="hljs-number">25</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;astronaut.png&quot;</span>)`}}),ae=new ls({props:{code:`import PIL
import requests
import torch
from io import BytesIO

from diffusers import DiffusionPipeline, DPMSolverMultistepScheduler


def download_image(url):
    response = requests.get(url)
    return PIL.Image.open(BytesIO(response.content)).convert("RGB")


img_url = "https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo.png"
mask_url = "https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo_mask.png"

init_image = download_image(img_url).resize((512, 512))
mask_image = download_image(mask_url).resize((512, 512))

repo_id = "stabilityai/stable-diffusion-2-inpainting"
pipe = DiffusionPipeline.from_pretrained(repo_id, torch_dtype=torch.float16, revision="fp16")

pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to("cuda")

prompt = "Face of a yellow cat, high resolution, sitting on a park bench"
image = pipe(prompt=prompt, image=init_image, mask_image=mask_image, num_inference_steps=25).images[0]

image.save("yellow_cat.png")`,highlighted:`<span class="hljs-keyword">import</span> PIL
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline, DPMSolverMultistepScheduler


<span class="hljs-keyword">def</span> <span class="hljs-title function_">download_image</span>(<span class="hljs-params">url</span>):
    response = requests.get(url)
    <span class="hljs-keyword">return</span> PIL.Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)


img_url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo.png&quot;</span>
mask_url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/latent-diffusion/main/data/inpainting_examples/overture-creations-5sI6fQgYIuo_mask.png&quot;</span>

init_image = download_image(img_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))
mask_image = download_image(mask_url).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))

repo_id = <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-inpainting&quot;</span>
pipe = DiffusionPipeline.from_pretrained(repo_id, torch_dtype=torch.float16, revision=<span class="hljs-string">&quot;fp16&quot;</span>)

pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;Face of a yellow cat, high resolution, sitting on a park bench&quot;</span>
image = pipe(prompt=prompt, image=init_image, mask_image=mask_image, num_inference_steps=<span class="hljs-number">25</span>).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;yellow_cat.png&quot;</span>)`}}),re=new ls({props:{code:`import requests
from PIL import Image
from io import BytesIO
from diffusers import StableDiffusionUpscalePipeline
import torch

# load model and scheduler
model_id = "stabilityai/stable-diffusion-x4-upscaler"
pipeline = StableDiffusionUpscalePipeline.from_pretrained(model_id, revision="fp16", torch_dtype=torch.float16)
pipeline = pipeline.to("cuda")

# let's download an  image
url = "https://huggingface.co/datasets/hf-internal-testing/diffusers-images/resolve/main/sd2-upscale/low_res_cat.png"
response = requests.get(url)
low_res_img = Image.open(BytesIO(response.content)).convert("RGB")
low_res_img = low_res_img.resize((128, 128))
prompt = "a white cat"
upscaled_image = pipeline(prompt=prompt, image=low_res_img).images[0]
upscaled_image.save("upsampled_cat.png")`,highlighted:`<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionUpscalePipeline
<span class="hljs-keyword">import</span> torch

<span class="hljs-comment"># load model and scheduler</span>
model_id = <span class="hljs-string">&quot;stabilityai/stable-diffusion-x4-upscaler&quot;</span>
pipeline = StableDiffusionUpscalePipeline.from_pretrained(model_id, revision=<span class="hljs-string">&quot;fp16&quot;</span>, torch_dtype=torch.float16)
pipeline = pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># let&#x27;s download an  image</span>
url = <span class="hljs-string">&quot;https://huggingface.co/datasets/hf-internal-testing/diffusers-images/resolve/main/sd2-upscale/low_res_cat.png&quot;</span>
response = requests.get(url)
low_res_img = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
low_res_img = low_res_img.resize((<span class="hljs-number">128</span>, <span class="hljs-number">128</span>))
prompt = <span class="hljs-string">&quot;a white cat&quot;</span>
upscaled_image = pipeline(prompt=prompt, image=low_res_img).images[<span class="hljs-number">0</span>]
upscaled_image.save(<span class="hljs-string">&quot;upsampled_cat.png&quot;</span>)`}}),oe=new Ms({}),ne=new ls({props:{code:`from diffusers import StableDiffusionPipeline, EulerDiscreteScheduler

pipeline = StableDiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2")
pipeline.scheduler = EulerDiscreteScheduler.from_config(pipeline.scheduler.config)

# or
euler_scheduler = EulerDiscreteScheduler.from_pretrained("stabilityai/stable-diffusion-2", subfolder="scheduler")
pipeline = StableDiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2", scheduler=euler_scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline, EulerDiscreteScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = EulerDiscreteScheduler.from_config(pipeline.scheduler.config)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># or</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>euler_scheduler = EulerDiscreteScheduler.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2&quot;</span>, subfolder=<span class="hljs-string">&quot;scheduler&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2&quot;</span>, scheduler=euler_scheduler)`}}),{c(){v=l("meta"),rs=u(),w=l("h1"),T=l("a"),Be=l("span"),k(R.$$.fragment),Ls=u(),Ce=l("span"),Ns=i("Stable diffusion 2"),os=u(),m=l("p"),Ts=i("Stable Diffusion 2 is a text-to-image "),He=l("em"),Os=i("latent diffusion"),Us=i(" model built upon the work of "),z=l("a"),Bs=i("Stable Diffusion 1"),Cs=i(`.
The project to train Stable Diffusion 2 was led by Robin Rombach and Katherine Crowson from `),V=l("a"),Hs=i("Stability AI"),Fs=i(" and "),Y=l("a"),Rs=i("LAION"),zs=i("."),ns=u(),pe=l("p"),y=l("em"),Vs=i(`The Stable Diffusion 2.0 release includes robust text-to-image models trained using a brand new text encoder (OpenCLIP), developed by LAION with support from Stability AI, which greatly improves the quality of the generated images compared to earlier V1 releases. The text-to-image models in this release can generate images with default resolutions of both 512x512 pixels and 768x768 pixels.
These models are trained on an aesthetic subset of the `),G=l("a"),Ys=i("LAION-5B dataset"),Gs=i(" created by the DeepFloyd team at Stability AI, which is then further filtered to remove adult content using "),Q=l("a"),Qs=i("LAION\u2019s NSFW filter"),Ws=i("."),ps=u(),O=l("p"),Ks=i("For more details about how Stable Diffusion 2 works and how it differs from Stable Diffusion 1, please refer to the official "),W=l("a"),Js=i("launch announcement post"),Xs=i("."),fs=u(),S=l("h2"),U=l("a"),Fe=l("span"),k(K.$$.fragment),Zs=u(),Re=l("span"),et=i("Tips"),us=u(),E=l("h3"),B=l("a"),ze=l("span"),k(J.$$.fragment),st=u(),Ve=l("span"),tt=i("Available checkpoints:"),hs=u(),_=l("p"),it=i("Note that the architecture is more or less identical to "),fe=l("a"),at=i("Stable Diffusion 1"),lt=i(" so please refer to "),ue=l("a"),rt=i("this page"),ot=i(" for API documentation."),cs=u(),g=l("ul"),D=l("li"),Ye=l("em"),nt=i("Text-to-Image (512x512 resolution)"),pt=i(": "),X=l("a"),ft=i("stabilityai/stable-diffusion-2-base"),ut=i(" with "),he=l("a"),ht=i("StableDiffusionPipeline"),ct=u(),j=l("li"),Ge=l("em"),dt=i("Text-to-Image (768x768 resolution)"),mt=i(": "),Z=l("a"),gt=i("stabilityai/stable-diffusion-2"),_t=i(" with "),ce=l("a"),bt=i("StableDiffusionPipeline"),vt=u(),I=l("li"),Qe=l("em"),wt=i("Image Inpainting (512x512 resolution)"),yt=i(": "),ee=l("a"),St=i("stabilityai/stable-diffusion-2-inpainting"),Et=i(" with "),de=l("a"),Dt=i("StableDiffusionInpaintPipeline"),jt=u(),P=l("li"),We=l("em"),It=i("Image Upscaling (x4 resolution resolution)"),Pt=i(": "),se=l("a"),qt=i("stable-diffusion-x4-upscaler"),$t=u(),me=l("a"),kt=i("StableDiffusionUpscalePipeline"),ds=u(),C=l("p"),xt=i("We recommend using the "),ge=l("a"),At=i("DPMSolverMultistepScheduler"),Mt=i(" as it\u2019s currently the fastest scheduler there is."),ms=u(),_e=l("ul"),be=l("li"),Ke=l("em"),Lt=i("Text-to-Image (512x512 resolution)"),Nt=i(":"),gs=u(),k(te.$$.fragment),_s=u(),ve=l("ul"),we=l("li"),Je=l("em"),Tt=i("Text-to-Image (768x768 resolution)"),Ot=i(":"),bs=u(),k(ie.$$.fragment),vs=u(),ye=l("ul"),Se=l("li"),Xe=l("em"),Ut=i("Image Inpainting (512x512 resolution)"),Bt=i(":"),ws=u(),k(ae.$$.fragment),ys=u(),Ee=l("ul"),q=l("li"),Ze=l("em"),Ct=i("Image Upscaling (x4 resolution resolution)"),Ht=i(": "),le=l("a"),Ft=i("stable-diffusion-x4-upscaler"),Rt=u(),De=l("a"),zt=i("StableDiffusionUpscalePipeline"),Ss=u(),k(re.$$.fragment),Es=u(),$=l("h3"),H=l("a"),es=l("span"),k(oe.$$.fragment),Vt=u(),ss=l("span"),Yt=i("How to load and use different schedulers."),Ds=u(),c=l("p"),Gt=i("The stable diffusion pipeline uses "),je=l("a"),Qt=i("DDIMScheduler"),Wt=i(" scheduler by default. But "),ts=l("code"),Kt=i("diffusers"),Jt=i(" provides many other schedulers that can be used with the stable diffusion pipeline such as "),Ie=l("a"),Xt=i("PNDMScheduler"),Zt=i(", "),Pe=l("a"),ei=i("LMSDiscreteScheduler"),si=i(", "),qe=l("a"),ti=i("EulerDiscreteScheduler"),ii=i(", "),$e=l("a"),ai=i("EulerAncestralDiscreteScheduler"),li=i(` etc.
To use a different scheduler, you can either change it via the `),ke=l("a"),ri=i("ConfigMixin.from_config()"),oi=i(" method or pass the "),is=l("code"),ni=i("scheduler"),pi=i(" argument to the "),as=l("code"),fi=i("from_pretrained"),ui=i(" method of the pipeline. For example, to use the "),xe=l("a"),hi=i("EulerDiscreteScheduler"),ci=i(", you can do the following:"),js=u(),k(ne.$$.fragment),this.h()},l(s){const p=Sa('[data-svelte="svelte-1phssyn"]',document.head);v=r(p,"META",{name:!0,content:!0}),p.forEach(t),rs=h(s),w=r(s,"H1",{class:!0});var Ps=o(w);T=r(Ps,"A",{id:!0,class:!0,href:!0});var bi=o(T);Be=r(bi,"SPAN",{});var vi=o(Be);x(R.$$.fragment,vi),vi.forEach(t),bi.forEach(t),Ls=h(Ps),Ce=r(Ps,"SPAN",{});var wi=o(Ce);Ns=a(wi,"Stable diffusion 2"),wi.forEach(t),Ps.forEach(t),os=h(s),m=r(s,"P",{});var b=o(m);Ts=a(b,"Stable Diffusion 2 is a text-to-image "),He=r(b,"EM",{});var yi=o(He);Os=a(yi,"latent diffusion"),yi.forEach(t),Us=a(b," model built upon the work of "),z=r(b,"A",{href:!0,rel:!0});var Si=o(z);Bs=a(Si,"Stable Diffusion 1"),Si.forEach(t),Cs=a(b,`.
The project to train Stable Diffusion 2 was led by Robin Rombach and Katherine Crowson from `),V=r(b,"A",{href:!0,rel:!0});var Ei=o(V);Hs=a(Ei,"Stability AI"),Ei.forEach(t),Fs=a(b," and "),Y=r(b,"A",{href:!0,rel:!0});var Di=o(Y);Rs=a(Di,"LAION"),Di.forEach(t),zs=a(b,"."),b.forEach(t),ns=h(s),pe=r(s,"P",{});var ji=o(pe);y=r(ji,"EM",{});var Ae=o(y);Vs=a(Ae,`The Stable Diffusion 2.0 release includes robust text-to-image models trained using a brand new text encoder (OpenCLIP), developed by LAION with support from Stability AI, which greatly improves the quality of the generated images compared to earlier V1 releases. The text-to-image models in this release can generate images with default resolutions of both 512x512 pixels and 768x768 pixels.
These models are trained on an aesthetic subset of the `),G=r(Ae,"A",{href:!0,rel:!0});var Ii=o(G);Ys=a(Ii,"LAION-5B dataset"),Ii.forEach(t),Gs=a(Ae," created by the DeepFloyd team at Stability AI, which is then further filtered to remove adult content using "),Q=r(Ae,"A",{href:!0,rel:!0});var Pi=o(Q);Qs=a(Pi,"LAION\u2019s NSFW filter"),Pi.forEach(t),Ws=a(Ae,"."),Ae.forEach(t),ji.forEach(t),ps=h(s),O=r(s,"P",{});var qs=o(O);Ks=a(qs,"For more details about how Stable Diffusion 2 works and how it differs from Stable Diffusion 1, please refer to the official "),W=r(qs,"A",{href:!0,rel:!0});var qi=o(W);Js=a(qi,"launch announcement post"),qi.forEach(t),Xs=a(qs,"."),qs.forEach(t),fs=h(s),S=r(s,"H2",{class:!0});var $s=o(S);U=r($s,"A",{id:!0,class:!0,href:!0});var $i=o(U);Fe=r($i,"SPAN",{});var ki=o(Fe);x(K.$$.fragment,ki),ki.forEach(t),$i.forEach(t),Zs=h($s),Re=r($s,"SPAN",{});var xi=o(Re);et=a(xi,"Tips"),xi.forEach(t),$s.forEach(t),us=h(s),E=r(s,"H3",{class:!0});var ks=o(E);B=r(ks,"A",{id:!0,class:!0,href:!0});var Ai=o(B);ze=r(Ai,"SPAN",{});var Mi=o(ze);x(J.$$.fragment,Mi),Mi.forEach(t),Ai.forEach(t),st=h(ks),Ve=r(ks,"SPAN",{});var Li=o(Ve);tt=a(Li,"Available checkpoints:"),Li.forEach(t),ks.forEach(t),hs=h(s),_=r(s,"P",{});var Me=o(_);it=a(Me,"Note that the architecture is more or less identical to "),fe=r(Me,"A",{href:!0});var Ni=o(fe);at=a(Ni,"Stable Diffusion 1"),Ni.forEach(t),lt=a(Me," so please refer to "),ue=r(Me,"A",{href:!0});var Ti=o(ue);rt=a(Ti,"this page"),Ti.forEach(t),ot=a(Me," for API documentation."),Me.forEach(t),cs=h(s),g=r(s,"UL",{});var F=o(g);D=r(F,"LI",{});var Le=o(D);Ye=r(Le,"EM",{});var Oi=o(Ye);nt=a(Oi,"Text-to-Image (512x512 resolution)"),Oi.forEach(t),pt=a(Le,": "),X=r(Le,"A",{href:!0,rel:!0});var Ui=o(X);ft=a(Ui,"stabilityai/stable-diffusion-2-base"),Ui.forEach(t),ut=a(Le," with "),he=r(Le,"A",{href:!0});var Bi=o(he);ht=a(Bi,"StableDiffusionPipeline"),Bi.forEach(t),Le.forEach(t),ct=h(F),j=r(F,"LI",{});var Ne=o(j);Ge=r(Ne,"EM",{});var Ci=o(Ge);dt=a(Ci,"Text-to-Image (768x768 resolution)"),Ci.forEach(t),mt=a(Ne,": "),Z=r(Ne,"A",{href:!0,rel:!0});var Hi=o(Z);gt=a(Hi,"stabilityai/stable-diffusion-2"),Hi.forEach(t),_t=a(Ne," with "),ce=r(Ne,"A",{href:!0});var Fi=o(ce);bt=a(Fi,"StableDiffusionPipeline"),Fi.forEach(t),Ne.forEach(t),vt=h(F),I=r(F,"LI",{});var Te=o(I);Qe=r(Te,"EM",{});var Ri=o(Qe);wt=a(Ri,"Image Inpainting (512x512 resolution)"),Ri.forEach(t),yt=a(Te,": "),ee=r(Te,"A",{href:!0,rel:!0});var zi=o(ee);St=a(zi,"stabilityai/stable-diffusion-2-inpainting"),zi.forEach(t),Et=a(Te," with "),de=r(Te,"A",{href:!0});var Vi=o(de);Dt=a(Vi,"StableDiffusionInpaintPipeline"),Vi.forEach(t),Te.forEach(t),jt=h(F),P=r(F,"LI",{});var Oe=o(P);We=r(Oe,"EM",{});var Yi=o(We);It=a(Yi,"Image Upscaling (x4 resolution resolution)"),Yi.forEach(t),Pt=a(Oe,": "),se=r(Oe,"A",{href:!0,rel:!0});var Gi=o(se);qt=a(Gi,"stable-diffusion-x4-upscaler"),Gi.forEach(t),$t=h(Oe),me=r(Oe,"A",{href:!0});var Qi=o(me);kt=a(Qi,"StableDiffusionUpscalePipeline"),Qi.forEach(t),Oe.forEach(t),F.forEach(t),ds=h(s),C=r(s,"P",{});var xs=o(C);xt=a(xs,"We recommend using the "),ge=r(xs,"A",{href:!0});var Wi=o(ge);At=a(Wi,"DPMSolverMultistepScheduler"),Wi.forEach(t),Mt=a(xs," as it\u2019s currently the fastest scheduler there is."),xs.forEach(t),ms=h(s),_e=r(s,"UL",{});var Ki=o(_e);be=r(Ki,"LI",{});var di=o(be);Ke=r(di,"EM",{});var Ji=o(Ke);Lt=a(Ji,"Text-to-Image (512x512 resolution)"),Ji.forEach(t),Nt=a(di,":"),di.forEach(t),Ki.forEach(t),gs=h(s),x(te.$$.fragment,s),_s=h(s),ve=r(s,"UL",{});var Xi=o(ve);we=r(Xi,"LI",{});var mi=o(we);Je=r(mi,"EM",{});var Zi=o(Je);Tt=a(Zi,"Text-to-Image (768x768 resolution)"),Zi.forEach(t),Ot=a(mi,":"),mi.forEach(t),Xi.forEach(t),bs=h(s),x(ie.$$.fragment,s),vs=h(s),ye=r(s,"UL",{});var ea=o(ye);Se=r(ea,"LI",{});var gi=o(Se);Xe=r(gi,"EM",{});var sa=o(Xe);Ut=a(sa,"Image Inpainting (512x512 resolution)"),sa.forEach(t),Bt=a(gi,":"),gi.forEach(t),ea.forEach(t),ws=h(s),x(ae.$$.fragment,s),ys=h(s),Ee=r(s,"UL",{});var ta=o(Ee);q=r(ta,"LI",{});var Ue=o(q);Ze=r(Ue,"EM",{});var ia=o(Ze);Ct=a(ia,"Image Upscaling (x4 resolution resolution)"),ia.forEach(t),Ht=a(Ue,": "),le=r(Ue,"A",{href:!0,rel:!0});var aa=o(le);Ft=a(aa,"stable-diffusion-x4-upscaler"),aa.forEach(t),Rt=h(Ue),De=r(Ue,"A",{href:!0});var la=o(De);zt=a(la,"StableDiffusionUpscalePipeline"),la.forEach(t),Ue.forEach(t),ta.forEach(t),Ss=h(s),x(re.$$.fragment,s),Es=h(s),$=r(s,"H3",{class:!0});var As=o($);H=r(As,"A",{id:!0,class:!0,href:!0});var ra=o(H);es=r(ra,"SPAN",{});var oa=o(es);x(oe.$$.fragment,oa),oa.forEach(t),ra.forEach(t),Vt=h(As),ss=r(As,"SPAN",{});var na=o(ss);Yt=a(na,"How to load and use different schedulers."),na.forEach(t),As.forEach(t),Ds=h(s),c=r(s,"P",{});var d=o(c);Gt=a(d,"The stable diffusion pipeline uses "),je=r(d,"A",{href:!0});var pa=o(je);Qt=a(pa,"DDIMScheduler"),pa.forEach(t),Wt=a(d," scheduler by default. But "),ts=r(d,"CODE",{});var fa=o(ts);Kt=a(fa,"diffusers"),fa.forEach(t),Jt=a(d," provides many other schedulers that can be used with the stable diffusion pipeline such as "),Ie=r(d,"A",{href:!0});var ua=o(Ie);Xt=a(ua,"PNDMScheduler"),ua.forEach(t),Zt=a(d,", "),Pe=r(d,"A",{href:!0});var ha=o(Pe);ei=a(ha,"LMSDiscreteScheduler"),ha.forEach(t),si=a(d,", "),qe=r(d,"A",{href:!0});var ca=o(qe);ti=a(ca,"EulerDiscreteScheduler"),ca.forEach(t),ii=a(d,", "),$e=r(d,"A",{href:!0});var da=o($e);ai=a(da,"EulerAncestralDiscreteScheduler"),da.forEach(t),li=a(d,` etc.
To use a different scheduler, you can either change it via the `),ke=r(d,"A",{href:!0});var ma=o(ke);ri=a(ma,"ConfigMixin.from_config()"),ma.forEach(t),oi=a(d," method or pass the "),is=r(d,"CODE",{});var ga=o(is);ni=a(ga,"scheduler"),ga.forEach(t),pi=a(d," argument to the "),as=r(d,"CODE",{});var _a=o(as);fi=a(_a,"from_pretrained"),_a.forEach(t),ui=a(d," method of the pipeline. For example, to use the "),xe=r(d,"A",{href:!0});var ba=o(xe);hi=a(ba,"EulerDiscreteScheduler"),ba.forEach(t),ci=a(d,", you can do the following:"),d.forEach(t),js=h(s),x(ne.$$.fragment,s),this.h()},h(){n(v,"name","hf:doc:metadata"),n(v,"content",JSON.stringify(Ia)),n(T,"id","stable-diffusion-2"),n(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),n(T,"href","#stable-diffusion-2"),n(w,"class","relative group"),n(z,"href","https://stability.ai/blog/stable-diffusion-public-release"),n(z,"rel","nofollow"),n(V,"href","https://stability.ai/"),n(V,"rel","nofollow"),n(Y,"href","https://laion.ai/"),n(Y,"rel","nofollow"),n(G,"href","https://laion.ai/blog/laion-5b/"),n(G,"rel","nofollow"),n(Q,"href","https://openreview.net/forum?id=M3Y74vmsMcY"),n(Q,"rel","nofollow"),n(W,"href","https://stability.ai/blog/stable-diffusion-v2-release"),n(W,"rel","nofollow"),n(U,"id","tips"),n(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),n(U,"href","#tips"),n(S,"class","relative group"),n(B,"id","available-checkpoints"),n(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),n(B,"href","#available-checkpoints"),n(E,"class","relative group"),n(fe,"href","./api/pipelines/stable_diffusion"),n(ue,"href","./api/pipelines/stable_diffusion"),n(X,"href","https://huggingface.co/stabilityai/stable-diffusion-2-base"),n(X,"rel","nofollow"),n(he,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionPipeline"),n(Z,"href","https://huggingface.co/stabilityai/stable-diffusion-2"),n(Z,"rel","nofollow"),n(ce,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionPipeline"),n(ee,"href","https://huggingface.co/stabilityai/stable-diffusion-2-inpainting"),n(ee,"rel","nofollow"),n(de,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionInpaintPipeline"),n(se,"href","https://huggingface.co/stabilityai/stable-diffusion-x4-upscaler"),n(se,"rel","nofollow"),n(me,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionUpscalePipeline"),n(ge,"href","/docs/diffusers/main/en/api/schedulers#diffusers.DPMSolverMultistepScheduler"),n(le,"href","https://huggingface.co/stabilityai/stable-diffusion-x4-upscaler"),n(le,"rel","nofollow"),n(De,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion#diffusers.StableDiffusionUpscalePipeline"),n(H,"id","how-to-load-and-use-different-schedulers"),n(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),n(H,"href","#how-to-load-and-use-different-schedulers"),n($,"class","relative group"),n(je,"href","/docs/diffusers/main/en/api/schedulers#diffusers.DDIMScheduler"),n(Ie,"href","/docs/diffusers/main/en/api/schedulers#diffusers.PNDMScheduler"),n(Pe,"href","/docs/diffusers/main/en/api/schedulers#diffusers.LMSDiscreteScheduler"),n(qe,"href","/docs/diffusers/main/en/api/schedulers#diffusers.EulerDiscreteScheduler"),n($e,"href","/docs/diffusers/main/en/api/schedulers#diffusers.EulerAncestralDiscreteScheduler"),n(ke,"href","/docs/diffusers/main/en/using-diffusers/configuration#diffusers.ConfigMixin.from_config"),n(xe,"href","/docs/diffusers/main/en/api/schedulers#diffusers.EulerDiscreteScheduler")},m(s,p){e(document.head,v),f(s,rs,p),f(s,w,p),e(w,T),e(T,Be),A(R,Be,null),e(w,Ls),e(w,Ce),e(Ce,Ns),f(s,os,p),f(s,m,p),e(m,Ts),e(m,He),e(He,Os),e(m,Us),e(m,z),e(z,Bs),e(m,Cs),e(m,V),e(V,Hs),e(m,Fs),e(m,Y),e(Y,Rs),e(m,zs),f(s,ns,p),f(s,pe,p),e(pe,y),e(y,Vs),e(y,G),e(G,Ys),e(y,Gs),e(y,Q),e(Q,Qs),e(y,Ws),f(s,ps,p),f(s,O,p),e(O,Ks),e(O,W),e(W,Js),e(O,Xs),f(s,fs,p),f(s,S,p),e(S,U),e(U,Fe),A(K,Fe,null),e(S,Zs),e(S,Re),e(Re,et),f(s,us,p),f(s,E,p),e(E,B),e(B,ze),A(J,ze,null),e(E,st),e(E,Ve),e(Ve,tt),f(s,hs,p),f(s,_,p),e(_,it),e(_,fe),e(fe,at),e(_,lt),e(_,ue),e(ue,rt),e(_,ot),f(s,cs,p),f(s,g,p),e(g,D),e(D,Ye),e(Ye,nt),e(D,pt),e(D,X),e(X,ft),e(D,ut),e(D,he),e(he,ht),e(g,ct),e(g,j),e(j,Ge),e(Ge,dt),e(j,mt),e(j,Z),e(Z,gt),e(j,_t),e(j,ce),e(ce,bt),e(g,vt),e(g,I),e(I,Qe),e(Qe,wt),e(I,yt),e(I,ee),e(ee,St),e(I,Et),e(I,de),e(de,Dt),e(g,jt),e(g,P),e(P,We),e(We,It),e(P,Pt),e(P,se),e(se,qt),e(P,$t),e(P,me),e(me,kt),f(s,ds,p),f(s,C,p),e(C,xt),e(C,ge),e(ge,At),e(C,Mt),f(s,ms,p),f(s,_e,p),e(_e,be),e(be,Ke),e(Ke,Lt),e(be,Nt),f(s,gs,p),A(te,s,p),f(s,_s,p),f(s,ve,p),e(ve,we),e(we,Je),e(Je,Tt),e(we,Ot),f(s,bs,p),A(ie,s,p),f(s,vs,p),f(s,ye,p),e(ye,Se),e(Se,Xe),e(Xe,Ut),e(Se,Bt),f(s,ws,p),A(ae,s,p),f(s,ys,p),f(s,Ee,p),e(Ee,q),e(q,Ze),e(Ze,Ct),e(q,Ht),e(q,le),e(le,Ft),e(q,Rt),e(q,De),e(De,zt),f(s,Ss,p),A(re,s,p),f(s,Es,p),f(s,$,p),e($,H),e(H,es),A(oe,es,null),e($,Vt),e($,ss),e(ss,Yt),f(s,Ds,p),f(s,c,p),e(c,Gt),e(c,je),e(je,Qt),e(c,Wt),e(c,ts),e(ts,Kt),e(c,Jt),e(c,Ie),e(Ie,Xt),e(c,Zt),e(c,Pe),e(Pe,ei),e(c,si),e(c,qe),e(qe,ti),e(c,ii),e(c,$e),e($e,ai),e(c,li),e(c,ke),e(ke,ri),e(c,oi),e(c,is),e(is,ni),e(c,pi),e(c,as),e(as,fi),e(c,ui),e(c,xe),e(xe,hi),e(c,ci),f(s,js,p),A(ne,s,p),Is=!0},p:Ea,i(s){Is||(M(R.$$.fragment,s),M(K.$$.fragment,s),M(J.$$.fragment,s),M(te.$$.fragment,s),M(ie.$$.fragment,s),M(ae.$$.fragment,s),M(re.$$.fragment,s),M(oe.$$.fragment,s),M(ne.$$.fragment,s),Is=!0)},o(s){L(R.$$.fragment,s),L(K.$$.fragment,s),L(J.$$.fragment,s),L(te.$$.fragment,s),L(ie.$$.fragment,s),L(ae.$$.fragment,s),L(re.$$.fragment,s),L(oe.$$.fragment,s),L(ne.$$.fragment,s),Is=!1},d(s){t(v),s&&t(rs),s&&t(w),N(R),s&&t(os),s&&t(m),s&&t(ns),s&&t(pe),s&&t(ps),s&&t(O),s&&t(fs),s&&t(S),N(K),s&&t(us),s&&t(E),N(J),s&&t(hs),s&&t(_),s&&t(cs),s&&t(g),s&&t(ds),s&&t(C),s&&t(ms),s&&t(_e),s&&t(gs),N(te,s),s&&t(_s),s&&t(ve),s&&t(bs),N(ie,s),s&&t(vs),s&&t(ye),s&&t(ws),N(ae,s),s&&t(ys),s&&t(Ee),s&&t(Ss),N(re,s),s&&t(Es),s&&t($),N(oe),s&&t(Ds),s&&t(c),s&&t(js),N(ne,s)}}}const Ia={local:"stable-diffusion-2",sections:[{local:"tips",sections:[{local:"available-checkpoints",title:"Available checkpoints:"},{local:"how-to-load-and-use-different-schedulers",title:"How to load and use different schedulers."}],title:"Tips"}],title:"Stable diffusion 2"};function Pa(_i){return Da(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class xa extends va{constructor(v){super();wa(this,v,Pa,ja,ya,{})}}export{xa as default,Ia as metadata};
